Subject: Ftp-WG: Re: receive "\n" as NOT obvious as send "\r\xFF"?

From: Jeffrey Altman <[email-masked]>
Date: Tue, 15 Jan 2002 17:33:27 -0500

> Maybe slowly I progress, thank you.  Let me echo back
> the distinction I hear you're making, you tell me how
> wrong I got it?
> 
> rfc2640 [International Ftp] and mlst-14 [More Ftp]
> merely emphasise what rfc854 [Telnet] said already:
> write \r\0 when \r is meant, write \xFF\xFF when \xFF
> is meant.

Not quite.  The rule is

  when sending as an NVT whenever a CR is transmitted
  by the application and the subsequent character is not
  LF, you must send a NUL.

  when receiving as an NVT whenever a CR is followed by
  a NUL, discard the NUL.

NVT mode is the default.  It can be overridden in either
direction by use of TELNET BINARY option.  However, this
is never done.

In all cases, the value 0xFF when sent by the application
must be quoted since it is the TELNET command introducer, IAC.

> To mention explicitly that people read \r\n where \n
> was written would be to mention new protocol. 
> Precisely defining a new protocol in order to
> discourage its use is ineffective, much like saying
> "don't think of pink elephants" is ineffective.
> 
> So far so good?  Anything wrong?  Anything omitted?

Not only would it be a new protocol, as a protocol it would 
break interoperability.  

 Jeffrey Altman * Sr.Software Designer      C-Kermit 8.0 available now!!!
 The Kermit Project @ Columbia University   includes Telnet, FTP and HTTP
 http://www.kermit-project.org/             secured with Kerberos, SRP, and 
 [email-masked]                OpenSSL. Interfaces with OpenSSH